// class flash.events.Event
joo.classLoader.prepare("package flash.events",
"public class Event",1,function($$private){var $1=flash.events;return[
"public native function get bubbles",
"public native function get cancelable",
"public native function get currentTarget",
"public native function get eventPhase",
"public native function get target",
"public native function get type",
"public function Event",function(type,bubbles,cancelable){switch(Math.max(arguments.length,1)){case 1:bubbles=false;case 2:cancelable=false;}
this['type']=type;
this['bubbles']=bubbles;
this['cancelable']=cancelable;
},
"public function clone",function(){
return new $1.Event(this.type,this.bubbles,this.cancelable);
},
"public function formatToString",function(className){var rest=Array.prototype.slice.call(arguments,1);
var sb=["[",className," "];
for(var i=0;i<rest.length;++i){
sb.push(rest[i],"=",this[rest[i]]," ");
}
sb.push("]");
return sb.join("");
},
"public function isDefaultPrevented",function(){
return this.defaultPrevented$1;
},
"public function preventDefault",function(){
if(this.cancelable){
this.defaultPrevented$1=true;
}
},
"public function stopImmediatePropagation",function(){
this.immediatePropagationStopped$1=true;
},
"public function stopPropagation",function(){
this.propagationStopped$1=true;
},
"public function toString",function(){
return this.formatToString("Event","type","bubbles","cancelable");
},
"public static const",{ACTIVATE:"activate"},
"public static const",{ADDED:"added"},
"public static const",{ADDED_TO_STAGE:"addedToStage"},
"public static const",{CANCEL:"cancel"},
"public static const",{CHANGE:"change"},
"public static const",{CLEAR:"clear"},
"public static const",{CLOSE:"close"},
"public static const",{COMPLETE:"complete"},
"public static const",{CONNECT:"connect"},
"public static const",{COPY:"copy"},
"public static const",{CUT:"cut"},
"public static const",{DEACTIVATE:"deactivate"},
"public static const",{ENTER_FRAME:"enterFrame"},
"public static const",{EXIT_FRAME:"exitFrame"},
"public static const",{FRAME_CONSTRUCTED:"frameConstructed"},
"public static const",{FULLSCREEN:"fullScreen"},
"public static const",{ID3:"id3"},
"public static const",{INIT:"init"},
"public static const",{MOUSE_LEAVE:"mouseLeave"},
"public static const",{OPEN:"open"},
"public static const",{PASTE:"paste"},
"public static const",{REMOVED:"removed"},
"public static const",{REMOVED_FROM_STAGE:"removedFromStage"},
"public static const",{RENDER:"render"},
"public static const",{RESIZE:"resize"},
"public static const",{SCROLL:"scroll"},
"public static const",{SELECT:"select"},
"public static const",{SELECT_ALL:"selectAll"},
"public static const",{SOUND_COMPLETE:"soundComplete"},
"public static const",{TAB_CHILDREN_CHANGE:"tabChildrenChange"},
"public static const",{TAB_ENABLED_CHANGE:"tabEnabledChange"},
"public static const",{TAB_INDEX_CHANGE:"tabIndexChange"},
"public static const",{TEXT_INTERACTION_MODE_CHANGE:"textInteractionModeChange"},
"public static const",{UNLOAD:"unload"},
"public function isPropagationStopped",function(){
return this.propagationStopped$1;
},
"public function isImmediatePropagationStopped",function(){
return this.immediatePropagationStopped$1;
},
"internal function withTarget",function(target){
var event=this.target?this.clone():this;
event['target']=target;
return event;
},
"internal function withCurrentTarget",function(currentTarget){
this['currentTarget']=currentTarget;
return this;
},
"private var",{defaultPrevented:false},
"private var",{propagationStopped:false},
"private var",{immediatePropagationStopped:false},
undefined];},[],[], "0.8.0", "2.0.12"
);
// class flash.events.EventDispatcher
joo.classLoader.prepare("package flash.events",
{Event:{name:"activate",type:"flash.events.Event"}},
{Event:{name:"deactivate",type:"flash.events.Event"}},
"public class EventDispatcher implements flash.events.IEventDispatcher",1,function($$private){var $1=flash.events;return[function(){joo.classLoader.init(flash.events.EventPhase);},
"public function EventDispatcher",function(target){joo.initField(this, "captureListeners$1");joo.initField(this, "listeners$1");if(arguments.length<=0)target=null;
this.target$1=target;
},
"public function addEventListener",function(type,listener,useCapture,priority,useWeakReference){switch(Math.max(arguments.length,2)){case 2:useCapture=false;case 3:priority=0;case 4:useWeakReference=false;}
var listenersByType=useCapture?this.captureListeners$1:this.listeners$1;
var eventObj={
type:type,
method:listener,
useCapture:useCapture,
priority:priority,
useWeakReference:useWeakReference
};
if(!(type in listenersByType)){
listenersByType[type]=[eventObj];
}else{
listenersByType[type].push(eventObj);
}
listenersByType[type].sort($$private.eventCompare);
},
"public function dispatchEvent",function(event){
event=event.withTarget(this.target$1||this);
var ancestors=this.createAncestorChain();
event['eventPhase']=$1.EventPhase.CAPTURING_PHASE;
$$private.internalHandleCapture(event,ancestors);
if(!event.isPropagationStopped()){
event['eventPhase']=$1.EventPhase.AT_TARGET;
event.withCurrentTarget(event.target);
var listeners=this.listeners$1[event.type];
if(listeners){
$$private.processListeners(event,listeners);
}
}
if(event.bubbles&&!event.isPropagationStopped()){
event['eventPhase']=$1.EventPhase.BUBBLING_PHASE;
$$private.internalHandleBubble(event,ancestors);
}
return!event.isDefaultPrevented();
},
"public function hasEventListener",function(type){
return this.listeners$1[type]||this.captureListeners$1[type];
},
"public function removeEventListener",function(type,listener,useCapture){if(arguments.length<=2)useCapture=false;
var listenersByType=useCapture?this.captureListeners$1:this.listeners$1;
var listeners=listenersByType[type];
if(listeners){
for(var i=0;i<listeners.length;++i){
if(listeners[i].method==listener){
if(listeners.length==1){
delete listenersByType[type];
}else{
listeners.splice(i,1);
}
break;
}
}
}
},
"public function willTrigger",function(type){
return this.hasEventListener(type);
},
"public function toString",function(){
return["EventDispatcher[target=",this.target$1,"]"].join("");
},
"public function processCapture",function(event){
event.withCurrentTarget(this.target$1||this);
var listeners=this.captureListeners$1[event.type];
if(listeners){
$$private.processListeners(event,listeners);
}
},
"public function processBubble",function(event){
event.withCurrentTarget(this.target$1||this);
var listeners=this.listeners$1[event.type];
if(listeners){
$$private.processListeners(event,listeners);
}
},
"private static function eventCompare",function(item1,item2){
if(item1.priority>item2.priority){
return-1;
}
else if(item1.priority<item2.priority){
return 1;
}
else{
return 0;
}
},
"public function createAncestorChain",function(){
return null;
},
"private static function internalHandleCapture",function(event,ancestors){
if(!ancestors||ancestors.length<=0){
return;
}
for(var i=ancestors.length-1;i>=0;i--){
var d=ancestors[i];
d.processCapture(event);
if(event.isPropagationStopped()){
break;
}
}
},
"private static function internalHandleBubble",function(event,ancestors){
if(!ancestors||ancestors.length<=0){
return;
}
for(var i=0;i<ancestors.length;i++){
var d=ancestors[i];
d.processBubble(event);
if(event.isPropagationStopped()){
break;
}
}
},
"private static function processListeners",function(event,listeners){
for(var i=0;i<listeners.length;++i){
if(listeners[i].method(event)===false){
event.stopPropagation();
event.preventDefault();
}
if(event.isImmediatePropagationStopped()){
break;
}
}
},
"private var",{captureListeners:function(){return({});}},
"private var",{listeners:function(){return({});}},
"private var",{target:null},
undefined];},[],["flash.events.IEventDispatcher","flash.events.EventPhase"], "0.8.0", "2.0.12"
);
// class flash.events.EventPhase
joo.classLoader.prepare("package flash.events",
"public final class EventPhase",1,function($$private){return[
"public static const",{AT_TARGET:2},
"public static const",{BUBBLING_PHASE:3},
"public static const",{CAPTURING_PHASE:1},
undefined];},[],[], "0.8.0", "2.0.12"
);
// class flash.events.IEventDispatcher
joo.classLoader.prepare("package flash.events",
"public interface IEventDispatcher",1,function($$private){return[,,,,,
undefined];},[],[], "0.8.0", "2.0.12"
);
// class flash.events.TimerEvent
joo.classLoader.prepare("package flash.events",
"public class TimerEvent extends flash.events.Event",2,function($$private){var $1=flash.events;return[
"public function TimerEvent",function(type,bubbles,cancelable){switch(Math.max(arguments.length,1)){case 1:bubbles=false;case 2:cancelable=false;}
$1.Event.call(this,type,bubbles,cancelable);
},
"override public function clone",function(){
return new $1.TimerEvent(this.type,this.bubbles,this.cancelable);
},
"override public function toString",function(){
return this.formatToString("TimerEvent","type","bubbles","cancelable");
},
"public function updateAfterEvent",function(){
},
"public static const",{TIMER:"timer"},
"public static const",{TIMER_COMPLETE:"timerComplete"},
undefined];},[],["flash.events.Event"], "0.8.0", "2.0.12"
);
// class flash.utils.applyWithRestParameters
joo.classLoader.prepare("package flash.utils",
"internal function applyWithRestParameters",0,function(){return function(closure,parameters){
switch(parameters.length){
case 0:return closure;
case 1:return function(){
return closure(parameters[0]);
};
case 2:return function(){
return closure(parameters[0],parameters[1]);
};
case 3:return function(){
return closure(parameters[0],parameters[1],parameters[2]);
};
default:return function(){
closure.apply(null,parameters);
};
}
}
;},[],[], "0.8.0", "2.0.12"
);
// class flash.utils.clearInterval
joo.classLoader.prepare("package flash.utils",
"public function clearInterval",0,function(){return function(id){
window.clearInterval(id);
}
;},[],["window"], "0.8.0", "2.0.12"
);
// class flash.utils.clearTimeout
joo.classLoader.prepare("package flash.utils",
"public function clearTimeout",0,function(){return function(id){
window.clearTimeout(id);
}
;},[],["window"], "0.8.0", "2.0.12"
);
// class flash.utils.describeType
joo.classLoader.prepare("package flash.utils",
"public function describeType",0,function(){var $2=flash.utils;return function(value){
var type=typeof value=="function"?value:value.constructor;
var len=0;
var methods={
length:function(){
return len;
}
};
function isGetterOrSetter(object,propertyName){
if(typeof Object['prototype'].__lookupGetter__!="function")
return false;
return object.__lookupGetter__(propertyName)||object.__lookupSetter__(propertyName);
}
if(type&&type.prototype){
for(var p in type.prototype){
if(p.match(/^[a-zA-Z_]/)&&!isGetterOrSetter(type.prototype,p)
&&typeof type.prototype[p]=="function"){
methods[len++]=p;
}
}
}
return{
attribute:function(attr){
return attr=="name"?$2.getQualifiedClassName(value):null;
},
method:{
"@name":methods
}
};
}
;},[],["flash.utils.getQualifiedClassName"], "0.8.0", "2.0.12"
);
// class flash.utils.Dictionary
joo.classLoader.prepare("package flash.utils",
"public dynamic class Dictionary",1,function($$private){var trace=joo.trace;return[
"public function Dictionary",function(weakKeys){if(arguments.length<=0)weakKeys=false;
if(weakKeys){
trace("[WARN]","Dictionary with weakKeys not supported by Jangaroo.");
}
},
undefined];},[],[], "0.8.0", "2.0.12"
);
// class flash.utils.getDefinitionByName
joo.classLoader.prepare("package flash.utils",
"public function getDefinitionByName",0,function(){var $1=joo;return function(name){
var clazz=$1.getQualifiedObject(name.replace("::","."));
if(typeof clazz!=='function'){
throw new ReferenceError(name);
}
return clazz;
}
;},[],[], "0.8.0", "2.0.12"
);
// class flash.utils.getQualifiedClassName
joo.classLoader.prepare("package flash.utils",
"public function getQualifiedClassName",0,function(){return function(value){
var type=typeof value=="function"?value:value.constructor;
return typeof type["$class"]=="object"?type["$class"]["fullClassName"].replace(/\.([^\.]+$)/,"::$1"):String(type);
}
;},[],[], "0.8.0", "2.0.12"
);
// class flash.utils.getQualifiedSuperclassName
joo.classLoader.prepare("package flash.utils",
"public function getQualifiedSuperclassName",0,function(){return function(value){
var type=typeof value=="function"?value:value.constructor;
return typeof type["$class"]=="object"?type["$class"]["superClassDeclaration"]["fullClassName"].replace(/\.([^\.]+$)/,"::$1"):String(type);
}
;},[],[], "0.8.0", "2.0.12"
);
// class flash.utils.getTimer
joo.classLoader.prepare("package flash.utils",
"public function getTimer",0,function(){var $1=joo;return function(){
return new Date().getTime()-$1.startTime;
}
;},[],["Date"], "0.8.0", "2.0.12"
);
// class flash.utils.setInterval
joo.classLoader.prepare("package flash.utils",
"public function setInterval",0,function(){var $1=flash.utils;return function(closure,delay){var rest=Array.prototype.slice.call(arguments,2);
var timeout=window.setInterval($1.applyWithRestParameters(closure,rest),delay);
return timeout;
}
;},[],["window","flash.utils.applyWithRestParameters"], "0.8.0", "2.0.12"
);
// class flash.utils.setTimeout
joo.classLoader.prepare("package flash.utils",
"public function setTimeout",0,function(){var $1=flash.utils;return function(closure,delay){var rest=Array.prototype.slice.call(arguments,2);
var timeout=window.setTimeout($1.applyWithRestParameters(closure,rest),delay);
return timeout;
}
;},[],["window","flash.utils.applyWithRestParameters"], "0.8.0", "2.0.12"
);
// class flash.utils.Timer
joo.classLoader.prepare("package flash.utils",
{Event:{name:"timer",type:"flash.events.TimerEvent"}},
{Event:{name:"timerComplete",type:"flash.events.TimerEvent"}},
"public class Timer extends flash.events.EventDispatcher",2,function($$private){var $$bound=joo.boundMethod,trace=joo.trace,$1=flash.events;return[function(){joo.classLoader.init(flash.events.TimerEvent);},
"public function get currentCount",function(){
return this._currentCount$2;
},
"public function get delay",function(){
return this._delay$2;
},
"public function set delay",function(value){
this._delay$2=value;
if(this.timer$2){
this.stop();
this.start();
}
},
"public function get repeatCount",function(){
return this._repeatCount$2;
},
"public function set repeatCount",function(value){
this._repeatCount$2=value;
this.checkComplete$2();
},
"public function get running",function(){
return this.timer$2!=null;
},
"public function Timer",function(delay,repeatCount){$1.EventDispatcher.call(this);if(arguments.length<=1)repeatCount=0;
this._delay$2=delay;
this._repeatCount$2=repeatCount;
},
"public function reset",function(){
this.stop();
this._currentCount$2=0;
},
"public function start",function(){
if(!this.timer$2){
this.timer$2=window.setInterval($$bound(this,"tick$2"),this._delay$2);
}
},
"public function stop",function(){
if(this.timer$2){
window.clearInterval(this.timer$2);
this.timer$2=null;
}
},
"private function tick",function(){
if(!this.timer$2){
return;
}
++this._currentCount$2;
try{
this.dispatchEvent(new $1.TimerEvent($1.TimerEvent.TIMER));
}catch(e){
trace("ERROR",e);
}
this.checkComplete$2();
},
"private function checkComplete",function(){
if(this._repeatCount$2>0&&this._currentCount$2>=this._repeatCount$2){
this.stop();
this.dispatchEvent(new $1.TimerEvent($1.TimerEvent.TIMER_COMPLETE));
}
},
"private var",{timer:null},
"private var",{_delay:NaN},
"private var",{_repeatCount:0},
"private var",{_currentCount:0},
undefined];},[],["flash.events.EventDispatcher","window","flash.events.TimerEvent"], "0.8.0", "2.0.12"
);
